/*
 * TGAFile.h
 *
 * Helper Class for TGA File In/Output
 *
 *  Created on: Aug 10, 2009
 *      Author: uncleben
 */

#ifndef TGAFILE_H_
#define TGAFILE_H_

class TGAFile {
public:
  TGAFile();
  TGAFile(const TGAFile &);
  ~TGAFile();

  void clear();

  inline int getWidth()  const { return width;  }
  inline int getHeight() const { return height; }
  inline int getBPP()    const { return bpp;    }

  inline const unsigned char *getData() const { return data; }

  bool load(const char *filename);
private:
  int width;
  int height;
  int bpp;

  unsigned char *data;
};


#endif /* TGAFILE_H_ */
