/*
 * mpi_communication.h
 *
 * In this file, all inter-process communication is defined
 *
 *  Created on: Oct 9, 2009
 *      Author: Benjamin Block

 * Copyright (C) 2010 Benjamin Block (http://www.lhyanor.org), 
 *                    Tobias Preis (http://tobiaspreis.de)
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 
 * 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public 
 * License along with this program; if not, see 
 * http://www.gnu.org/licenses/.
 */

#ifndef MPI_COMMUNICATION_H_
#define MPI_COMMUNICATION_H_

#include "core.h"

extern int rank, nthreads;

#ifdef MULTI_GPU
/* exchanges the border information over MPI */
void mpi_exchange_borders(IsingHostData *hdata, int myrank, int *myneighbours);
/* reduce magnetization */
void mpi_reduce_result(double *result, int numEntries);
/* initialize MPI */
void mpi_init(int argc, char **argv);
#endif


#endif /* MPI_COMMUNICATION_H_ */
